/*----------------------------------------------------------------------

	$B%U%!%$%kL>(B	gdp_c.c

	(C)1994 Institute for New Generation Computer Technology
	Read COPYRIGHT for detailed information.

----------------------------------------------------------------------*/
#include "2dp_new_klic.h"

long *amigapI,*amigapJ,*gapI,*gapJ;
extern long Dmatrix[26][26];

long
gdp_s(pa1,pa2,ostring,oleng,leng,nstring,nleng)
PARAM1 *pa1;
PARAM2 *pa2;
char *ostring;
long oleng,*leng;
char *nstring;
long *nleng;
{
  long i,j,I,J,buffx,buffy,num,numx,numy;
  long k,energy,cost;
  char p;

  VEC *Vec0;     /* Vec0[MAXBUFF]; */
  VEC *Vec1;     /* Vec1[MAXBUFF]; */

  PATH_s **Path;  /* Path[MAXBUFF*MAXBUFF]; */

  char **Seq1;           /* Seq1[SEQNUM*MAXBUFF]; */
  char **Seq2;           /* Seq2[SEQNUM*MAXBUFF]; */
  char **Seq;

  void remove_allgap();
  extern void generateD_00_s();
  extern void makeAlignmentString_s();
  long calc_energy();
  extern void keep_memory_s();
  extern void free_memory_s();

  extern char *calloc();

  numx = pa2->NumX;
  numy = pa2->NumY;
  num = numx + numy;

/*  fprintf(stdout,"(Cut,U,V,S)=(%d,%d,%d,%d)\n",pa1->Cut,pa1->U,pa1->V,pa1->S);*/

  if( ( Seq1 = (char **)calloc( numx, sizeof(char *) ) ) == NULL ){
    fprintf(stderr,"calloc failed for Seq1\n"); exit();
  }
  for(k=0;k<numx;k++){
    if( ( Seq1[k] = calloc( pa2->X, sizeof(char) ) ) == NULL ){
      fprintf(stderr,"calloc failed for Seq1\n"); exit();
    }
  }
  
  if( ( Seq2 = (char **)calloc( numy, sizeof(char *) ) ) == NULL ){
    fprintf(stderr,"calloc failed for Seq2\n"); exit();
  }
  for(k=0;k<numy;k++){
    if( ( Seq2[k] = calloc( pa2->Y, sizeof(char) ) ) == NULL ){
      fprintf(stderr,"calloc failed for Seq2\n"); exit();
    }
  }
  
  if( ( Seq = (char **)calloc( num, sizeof(char *) ) ) == NULL ){
    fprintf(stderr,"calloc failed for Seq1\n"); exit();
  }
  for(k=0;k<num;k++){
    if( ( Seq[k] = calloc( pa2->X + pa2->Y, sizeof(char) ) ) == NULL ){
      fprintf(stderr,"calloc failed for Seq1\n"); exit();
    }
  }
  
  k = 0;
  for(i=0;i<numx;i++){
    for(j=0;j<*leng;j++){
      p = ostring[k];
/*      fprintf(stdout,"%c",p);*/
      if(p >= 'a' && p <= 'z')  p -= 'a';
      if(p >= 'A' && p <= 'Z')  p -= 'A';
      Seq1[i][j] = p;
      k++;
    }
/*    fprintf(stdout,"\n");*/
  }
/*  fprintf(stdout,"\n");*/
  for(i=0;i<numy;i++){
    for(j=0;j<*leng;j++){
      p = ostring[k];
/*      fprintf(stdout,"%c",p);*/
      if(p >= 'a' && p <= 'z')  p -= 'a';
      if(p >= 'A' && p <= 'Z')  p -= 'A';
      Seq2[i][j] = p;
      k++;
    }
/*    fprintf(stdout,"\n");*/
  }
/*  fflush(stdout);*/

  if(k != oleng){
    fprintf(stderr,"k != oleng\n");
    exit();
  }

  free(ostring);

  remove_allgap(Seq1,Seq2,&(pa2->X),&(pa2->Y),numx,numy);

  buffx = pa2->X + 1;
  buffy = pa2->Y + 1;

  keep_memory_s(&Vec0,&Vec1,&Path,buffx,buffy);

  generateD_00_s(Vec0,Vec1,Path,Seq1,Seq2,pa1->U,pa1->V,pa1->S,pa1->Cut,
		 pa2->X,pa2->Y,numx,numy,&I,&J);
/*
  if(J % 2 == 0) cost = Vec0[I].xy;
  if(J % 2 == 1) cost = Vec1[I].xy;
  fprintf(stdout,"cost = %d\n",cost);
*/
  makeAlignmentString_s(Path,Seq1,Seq2,Seq,numx,numy,I,J,leng,Seq);

  k = 0;
  for(i=0;i<num;i++){
    for(j=0;j<*leng;j++){
      nstring[k] = Seq[i][*leng-1-j];
      k++;
    }
  }
  *nleng = k;

  energy = calc_energy(nstring,num,*leng,pa1->U,pa1->V,pa1->S);

  for(k=0;k<numx;k++) free(Seq1[k]);
  free(Seq1);

  for(k=0;k<numy;k++) free(Seq2[k]);
  free(Seq2);

  for(k=0;k<num;k++) free(Seq[k]);
  free(Seq);

  free_memory_s(Vec0,Vec1,Path,buffy);

  return energy;
}


long
gdp_b(pa1,pa2,ostring,oleng,leng,nstring,nleng)
PARAM1 *pa1;
PARAM2 *pa2;
char *ostring;
long oleng,*leng;
char *nstring;
long *nleng;
{
  long i,j,I,J,buffx,buffy,num,numx,numy;
  long k,energy,cost;

  VEC *Vec0;     /* Vec0[MAXBUFF]; */
  VEC *Vec1;     /* Vec1[MAXBUFF]; */

  PATH_b *Path0;   /* Path0[MAXBUFF]; */
  PATH_b *Path1;   /* Path1[MAXBUFF]; */

  PROF *ProfI;   /* ProfI[MAXBUFF]; */
  PROF *ProfJ;   /* ProfJ[MAXBUFF]; */

  char **Seq1;           /* Seq1[SEQNUM*MAXBUFF]; */
  char **Seq2;           /* Seq2[SEQNUM*MAXBUFF]; */
  char **Seq;

  void remove_allgap();
  extern void makeProf();
  extern void generateD_00_b();
  extern void makeAlignmentString_b();
  long calc_energy();
  extern void keep_memory_b();
  extern void free_memory_b();

  extern char *calloc();

  numx = pa2->NumX;
  numy = pa2->NumY;
  num = numx + numy;

/*  fprintf(stdout,"(Cut,U,V,S)=(%d,%d,%d,%d)\n",pa1->Cut,pa1->U,pa1->V,pa1->S);*/

  if( ( Seq1 = (char **)calloc( numx, sizeof(char *) ) ) == NULL ){
    fprintf(stderr,"calloc failed for Seq1\n"); exit();
  }
  for(k=0;k<numx;k++){
    if( ( Seq1[k] = calloc( pa2->X, sizeof(char) ) ) == NULL){
      fprintf(stderr,"calloc failed for Seq1\n"); exit();
    }
  }
  
  if( ( Seq2 = (char **)calloc( numy, sizeof(char *) ) ) == NULL ){
    fprintf(stderr,"calloc failed for Seq2\n"); exit();
  }
  for(k=0;k<numy;k++){
    if( ( Seq2[k] = calloc( pa2->Y, sizeof(char) ) ) == NULL ){
      fprintf(stderr,"calloc failed for Seq2\n"); exit();
    }
  }
  
  if( ( Seq = (char **)calloc( num, sizeof(char *) ) ) == NULL ){
    fprintf(stderr,"calloc failed for Seq1\n"); exit();
  }
  for(k=0;k<num;k++){
    if( ( Seq[k] = calloc( pa2->X + pa2->Y, sizeof(char) ) ) == NULL ){
      fprintf(stderr,"calloc failed for Seq1\n"); exit();
    }
  }
  
  if( ( amigapI = (long *)calloc( num, sizeof(long) ) ) == NULL ){
    fprintf(stderr,"calloc failed for amigapI\n"); exit();
  }

  if( ( amigapJ = (long *)calloc( num, sizeof(long) ) ) == NULL ){
    fprintf(stderr,"calloc failed for amigapJ\n"); exit();
  }

  if( ( gapI = (long *)calloc( num, sizeof(long) ) ) == NULL ){
    fprintf(stderr,"calloc failed for gapI\n"); exit();
  }

  if( ( gapJ = (long *)calloc( num, sizeof(long) ) ) == NULL ){
    fprintf(stderr,"calloc failed for gapJ\n"); exit();
  }

  k = 0;
  for(i=0;i<numx;i++){
    for(j=0;j<*leng;j++){
      Seq1[i][j] = ostring[k];
/*      fprintf(stdout,"%c",ostring[k]);*/
      k++;
    }
/*    fprintf(stdout,"\n");*/
  }
  for(i=0;i<numy;i++){
    for(j=0;j<*leng;j++){
      Seq2[i][j] = ostring[k];
/*      fprintf(stdout,"%c",ostring[k]);*/
      k++;
    }
/*    fprintf(stdout,"\n");*/
  }
/*  fflush(stdout);*/

  if(k != oleng){
    fprintf(stderr,"k != oleng\n");
    exit();
  }

  free(ostring);

  remove_allgap(Seq1,Seq2,&(pa2->X),&(pa2->Y),numx,numy);

  buffx = pa2->X + 1;
  buffy = pa2->Y + 1;

  keep_memory_b(&Vec0,&Vec1,&Path0,&Path1,&ProfI,&ProfJ,buffx,buffy,numx,numy);

  makeProf(ProfI,Seq1,pa2->X,numx);
  makeProf(ProfJ,Seq2,pa2->Y,numy);
/*
  fprintf(stdout,"ProfI=\n");
  printProf(ProfI,*X);
  fprintf(stdout,"ProfJ=\n");
  printProf(ProfJ,*Y);
*/
  generateD_00_b(Vec0,Vec1,Path0,Path1,ProfI,ProfJ,
		 pa1->U,pa1->V,pa1->S,pa1->Cut,pa2->X,pa2->Y,&I,&J);
/*
  if(J % 2 == 0) cost = Vec0[I].xy;
  if(J % 2 == 1) cost = Vec1[I].xy;
  fprintf(stdout,"cost = %d\n",cost);
*/
  if(J % 2 == 0) makeAlignmentString_b(Path0,Seq1,Seq2,Seq,numx,numy,pa2->X,pa2->Y,I,leng);
  if(J % 2 == 1) makeAlignmentString_b(Path1,Seq1,Seq2,Seq,numx,numy,pa2->X,pa2->Y,I,leng);

  k = 0;
  for(i=0;i<num;i++){
    for(j=0;j<*leng;j++){
      nstring[k] = Seq[i][j];
      k++;
    }
  }
  *nleng = k;

/*  energy = calc_energy(nstring,*nleng,num,*leng,pa1.U,pa1.V,pa1.S);*/
  energy = calc_energy(nstring,num,*leng,pa1->U,pa1->V,pa1->S);

  for(k=0;k<numx;k++) free(Seq1[k]);
  free(Seq1);

  for(k=0;k<numy;k++) free(Seq2[k]);
  free(Seq2);

  for(k=0;k<num;k++) free(Seq[k]);
  free(Seq);

  free_memory_b(Vec0,Vec1,Path0,Path1,ProfI,ProfJ,buffx,buffy);

  return energy;
}


long
calc_energy(str,num,leng,U,V,S)
char *str;
long num,leng,U,V,S;
{
  long i,j,k,K;
  long energy=0;
  
  for(i=0;i<num;i++){
    for(j=i+1;j<num;j++){
      for(k=0;k<leng;k++){
	if((str[i*leng + k] == '-' || str[i*leng + k] == '#') 
	   && (str[j*leng + k] == '-' || str[j*leng + k] == '#')) {}
	else if(str[i*leng + k] == '#' || str[j*leng + k] == '#') energy += (long)S;
	else if(str[i*leng + k] == '-'){
	  K = k;
	  for(;;){
	    K--;
	    if(str[i*leng + K] != '-'){
	      energy += (long)(U+V);
	      break;
	    }
	    else if(str[j*leng + K] != '-'){
	      energy += (long)V;
	      break;
	    }
	    else {}
	  }
	}
	else if(str[j*leng + k] == '-'){
	  K = k;
	  for(;;){
	    K--;
	    if(str[j*leng + K] != '-'){
	      energy += (long)(U+V);
	      break;
	    }
	    else if(str[i*leng + K] != '-'){
	      energy += (long)V;
	      break;
	    }
	    else {}
	  }
	}
	else{
	  energy += (long)Dmatrix[str[i*leng + k] - 'A'][str[j*leng + k] - 'A'];
	}
      }
    }
  }
  return energy;
}
      

void 
remove_allgap(Seq1,Seq2,X,Y,NumX,NumY)
char **Seq1;
char **Seq2;
long *X,*Y,NumX,NumY;
{
  long i,j,k,k1;

  j = 0;
  for(i=0;i<*X;i++){
    for(k=0;k<NumX;k++){
      if(Seq1[k][i] != '-' && Seq1[k][i] != '#'){
	for(k1=0;k1<NumX;k1++){
	  Seq1[k1][j] = Seq1[k1][i];
	}
	j++;
	break;
      }
      else {}
    }
  }
  *X = j;

  j = 0;
  for(i=0;i<*Y;i++){
    for(k=0;k<NumY;k++){
      if(Seq2[k][i] != '-' && Seq2[k][i] != '#'){
	for(k1=0;k1<NumY;k1++){
	  Seq2[k1][j] = Seq2[k1][i];
	}
	j++;
	break;
      }
      else {}
    }
  }
  *Y = j;
}
